=== debian/changelog ===
oxide-qt (1.7.9-0ubuntu0.14.10.1) utopic-security; urgency=medium

  * Update to v1.7.9
    - see USN-2652-1
    - Bump Chromium rev to 43.0.2357.130

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 23 Jun 2015 16:44:11 +0100

oxide-qt (1.7.8-0ubuntu0.14.10.1) utopic-security; urgency=medium

  * Update to v1.7.8
    - see USN-2610-1
    - Bump Chromium rev to 43.0.2357.65
    - Fix LP: #1452407 - Shutdown abort due to BrowserContext leak
    - Fix LP: #1449660 - Shutdown deadlock due to a race condition in
      WebContentsUnloader
    - Fix LP: #1435831 - Support EGLImage compositing path
    - Fix LP: #1435835 - Improve synchronization between webview and UI
      compositors
    - Fix LP: #1422408 - Enable accelerated canvas on Arale
    - Fix LP: #1426567 - Enable pinch-viewport on desktop
    - Fix LP: #1439829 - Select the correct GL platform when the Qt platform
      is "mirserver"
    - Fix LP: #1399195 - Improve network callback event tests
    - Fix LP: #1415662 - Cancelling a network request in onBeforeRedirect has
      no effect
    - Fix LP: #1422920 - Add LocationBarController.show(),
      LocationBarController.hide() and LocationBarController.animated
    - Fix LP: #1433472 - navigator.language doesn't work
    - Fix LP: #1435418 - Clean up the classes related to the private interfaces
      between the core library and the QtQuick library, making it more obvious
      where code should live
    - Fix LP: #1438902 - Enable webgl on mako
    - Fix LP: #1446864 - OxideQQuickScriptMessage::reply doesn't work with
      Qt 5.4
    - Use the simple backend for the network cache
    - Add EGLFS QPA support
    - Fix cross-compiling armhf builds on x86
  * Make sure that liboxideqtquick0 is stripped correctly

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 19 May 2015 17:43:04 +0100

oxide-qt (1.6.6-0ubuntu0.14.10.1) utopic-security; urgency=medium

  * Update to v1.6.6
    - see USN-2582-1
    - Bump Chromium rev to 42.0.2311.135

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 29 Apr 2015 21:18:14 +0100

oxide-qt (1.6.5-0ubuntu0.14.10.1) utopic-security; urgency=medium

  * Update to v1.6.5
    - see USN-2570-1
    - Bump Chromium rev to 42.0.2311.90
    - Fix LP: #1442398 - Invalid read in CompositorOutputSurfaceGL
    - Fix LP: #1442458 - Minimum page scale shouldn't be 1 on mobile
      form-factors
    - Fix LP: #1400372 - Keyboard re-appears in webbrowser after dismissing
    - Fix LP: #1429135 - webbrowser-app crashed with SIGSEGV in
      XQueryExtension() on Unity 8 desktop
    - Fix LP: #1411159 - Proper fix for shutdown crash in
      content::GpuChannelHost::Send, removing the workaround from the 1.5
      branch
    - Fix LP: #1277659 - Add WebContext.maxCacheSizeHint property, to allow
      applications some control over the network cache size
    - Fix LP: #1427882 - TextureRefHolder will crash if the context is lost
    - Fix LP: #1430478 - Disable the GPU shader cache. Its memory footprint
      makes it inappropriate on mobile devices and it writes the cache to the
      current working directory if WebContext.dataPath isn't set
    - Set the pulse audio media role so that audio output can take part in
      pulse-level stream arbitration
    - Disable webcore debug symbols and link with --no-keep-files-mapped
      on native x86 builds because of linker OOM
    - Add OXIDE_ENABLE_GPU_DEBUGGING environment variable, which corresponds
      to --enable-gpu-debugging in Chrome
    - Fix renderer crash in debug builds when location bar height is set to
      zero
    - Remove a spurious DCHECK that fires sometimes when a render process dies
    - Add resources and strings required for built-in webui (eg, chrome://gpu/)
    - Add OXIDE_ENABLE_GPU_SERVICE_LOGGING environment variable, which
      corresponds to --enable-gpu-service-logging in Chrome
    - Miscellaneous fixes for media-hub audio playback
    - Use base::ThreadRestrictions::ScopedAllowIO when constructing
      net::HttpCache, as that makes use of base::CPU which does IO on Arm.
      Fixes a debug-mode startup abort
    - Various component build fixes
    - Don't statically link base in to oxide-renderer just to call
      SetReleaseFreeMemoryFunction. Instead, expose an API from oxide-core to
      allow oxide-renderer to call this without pulling in its own copy of base
    - Only disable use of EGL_EXT_create_context_robustness and
      GLX_ARB_create_context_robustness when the application provides a share
      context that hasn't been created with these extensions
    - Add OXIDE_DISABLE_GPU_DRIVER_BUG_WORKAROUNDS environment variable
    - Drop support for building with Qt < 5.2
    - Use net::URLRequest::IsHandledProtocol for checking if a scheme is
      builtin
    - Refactor how the GL implementation is selected, simplifying the code.
      Also add OXIDE_DISABLE_GPU and OXIDE_DISABLE_GPU_COMPOSITING environment
      variables for disabling all GPU features or GPU compositing respectively
    - Fix LP: #1446864 - OxideQQuickScriptMessage::reply doesn't work with
      Qt 5.4

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 15 Apr 2015 12:50:01 +0100

oxide-qt (1.5.6-0ubuntu0.14.10.1) utopic-security; urgency=medium

  * Update to v1.5.6
    - Bump Chromium rev to 41.0.2272.118
    - see USN-2556-1

 -- Chris Coulson <chris.coulson@canonical.com>  Thu, 02 Apr 2015 15:33:10 +0100

oxide-qt (1.5.5-0ubuntu0.14.10.2) utopic-security; urgency=medium

  * Update to v1.5.5 - see USN-2521-1
    - Bump Chromium rev to 41.0.2272.76
    - Fix LP: #1427828 - Crash in WebFrame.sendMessageNoReply
    - Fix LP: #1411159 - Add work-around for shutdown crash in
      content::GpuChannelHost::Send, by deliberately leaking the
      cc::ContextProvider referenced by any task posted to the UI thread if
      the task never got a chance to run and is destroyed when the main loop
      is torn down. Note that 1.6 has the longer term fix for this crash.

